#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Change2CUI=y
#AutoIt3Wrapper_Res_Comment=Start program from the local SYSTEM account
#AutoIt3Wrapper_Res_Description=Start program from the local SYSTEM account
#AutoIt3Wrapper_Res_Fileversion=1.0.0.3
#Compiler_Res_Fileversion = 1.0.0.4; here come the version !
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; Much of the code is taken from wraithdu's examples
; Modified by Joakim

#include <WinAPI.au3>
#include <String.au3>

CONST $ERROR_INVALID_SID = 1337
Global Const $tagSTARTUPINFO1 = "dword cb;ptr lpReserved;ptr lpDesktop;ptr lpTitle;dword dwX;dword dwY;dword dwXSize;dword dwYSize;" & _
						"dword dwXCountChars;dword dwYCountChars;dword dwFillAttribute;dword dwFlags;ushort wShowWindow;" & _
						"ushort cbReserved2;ptr lpReserved2;ptr hStdInput;ptr hStdOutput;ptr hStdError"
Global Const $tagPROCESSINFO1 = "ptr hProcess;ptr hThread;dword dwProcessId;dword dwThreadId"
Global Const $NORMAL_PRIORITY_CLASS = 0x00000020
Global Const $CREATE_NEW_CONSOLE = 0x00000010
Global Const $CREATE_UNICODE_ENVIRONMENT = 0x00000400
Global Const $RPC_X_BAD_STUB_DATA = 1783
Global $ghADVAPI32 = DllOpen("advapi32.dll")

;ConsoleWrite("RunasSystem:" & @CRLF)
;Local $iAnswer = MsgBox(BitOR($MB_YESNO, $MB_SYSTEMMODAL), "RunasSystem", "1")

$Privs = "SeDebugPrivilege,SeAssignPrimaryTokenPrivilege,SeIncreaseQuotaPrivilege"
$PrivsArray = StringSplit($Privs,",")
For $i = 1 To $PrivsArray[0]
	ConsoleWrite("RunasSystem: Now setting privilege: " & $PrivsArray[$i] & @CRLF)
	_SetPrivilege($PrivsArray[$i])
Next
;If @error Then exit

If $cmdline[0] = 0 Then
	$sCmdLine = "cmd.exe"
Else
	$sCmdLine = $cmdline[1]
EndIf
$sProcessAsUser = "winlogon.exe"

$dwSessionId = DllCall("kernel32.dll", "dword", "WTSGetActiveConsoleSessionId")
If @error Or $dwSessionId[0] = 0xFFFFFFFF Then
	ConsoleWrite("RunasSystem: WTSGetActiveConsoleSessionId: " & _WinAPI_GetLastErrorMessage() & @CRLF)
	Exit
EndIf
$dwSessionId = $dwSessionId[0]
ConsoleWrite("RunasSystem: Running in session: " & $dwSessionId & @CRLF)
Dim $aProcs = ProcessList($sProcessAsUser), $processPID = -1, $ret
For $i = 1 To $aProcs[0][0]
	$ret = DllCall("kernel32.dll", "int", "ProcessIdToSessionId", "dword", $aProcs[$i][1], "dword*", 0)
	If Not @error And $ret[0] And ($ret[2] = $dwSessionId) Then
		$processPID = $aProcs[$i][1]
		ExitLoop
	EndIf
Next
ConsoleWrite("RunasSystem: Host PID: " & $processPID & @CRLF)
If $processPID = -1 Then
	ConsoleWrite("RunasSystem: Return 0 ; failed to get winlogon PID in current sessio")
	Exit
EndIf
Local $hProc = DllCall("kernel32.dll", "ptr", "OpenProcess", "dword", 0x001F0FFF, "int", 0, "dword", $processPID)
If @error Or Not $hProc[0] Then
	ConsoleWrite("RunasSystem: OpenProcess: " & _WinAPI_GetLastErrorMessage() & @CRLF)
	Exit
EndIf
$hProc = $hProc[0]
$hToken = DllCall($ghADVAPI32, "int", "OpenProcessToken", "ptr", $hProc, "dword", 0x2, "ptr*", 0)
If @error Or Not $hToken[0] Then
	ConsoleWrite("RunasSystem: OpenProcessToken: " & _WinAPI_GetLastErrorMessage() & @CRLF)
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
	Exit
EndIf
$hToken = $hToken[3]
$hDupToken = DllCall($ghADVAPI32, "int", "DuplicateTokenEx", "ptr", $hToken, "dword", 0x1F0FFF, "ptr", 0, "int", 1, "int", 1, "ptr*", 0)
If @error Or Not $hDupToken[0] Then
	ConsoleWrite("RunasSystem: DuplicateTokenEx: " & _WinAPI_GetLastErrorMessage() & @CRLF)
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
	Exit
EndIf
$hDupToken = $hDupToken[6]
ConsoleWrite("RunasSystem: sProcessAsUser=" & $sProcessAsUser & "  dwSessionId=" & $dwSessionId & @CRLF)
$pEnvBlock = _GetEnvironmentBlock($sProcessAsUser, $dwSessionId) ; target process

$dwCreationFlags = BitOR($NORMAL_PRIORITY_CLASS, $CREATE_NEW_CONSOLE)
If $pEnvBlock Then  $dwCreationFlags = BitOR($dwCreationFlags, $CREATE_UNICODE_ENVIRONMENT)
ConsoleWrite("RunasSystem: pEnvBlock=" & $pEnvBlock & "  dwCreationFlags=" & Hex($dwCreationFlags, 8) & @CRLF)
ConsoleWrite("RunasSystem: sCmdLine=" & $sCmdLine & "  WindowsDir=" & @WindowsDir & @CRLF)

$SI = DllStructCreate($tagSTARTUPINFO1)
DllStructSetData($SI, "cb", DllStructGetSize($SI))
$PI = DllStructCreate($tagPROCESSINFO1)
;ConsoleWrite("RunasSystem: DllStructGetSize($SI)=" & DllStructGetSize($SI) & "  DllStructGetSize($PI)=" & DllStructGetSize($PI) & @CRLF)

$sDesktop = "winsta0\default"
$lpDesktop = DllStructCreate("wchar[" & StringLen($sDesktop) + 1 & "]")
DllStructSetData($lpDesktop, 1, $sDesktop)
DllStructSetData($SI, "lpDesktop", DllStructGetPtr($lpDesktop))

_WinAPI_SetLastError(0)
$ret = DllCall($ghADVAPI32, "bool", "CreateProcessWithTokenW",  "handle", $hDupToken,  "dword", 1,  "ptr", 0,  "wstr", $sCmdLine,  "dword", $dwCreationFlags,  "ptr", $pEnvBlock,  "wstr", @WindowsDir,  "ptr", DllStructGetPtr($SI),  "ptr", DllStructGetPtr($PI))
ConsoleWrite("RunasSystem: CreateProcessWithTokenW=" & $ret[0] & "  error=" & @error & " LastError=" & _WinAPI_GetLastError() & @CRLF)

If Not $ret[0] and _WinAPI_GetLastError() = $RPC_X_BAD_STUB_DATA Then
	If $pEnvBlock Then  DllCall("userenv.dll", "int", "DestroyEnvironmentBlock", "ptr", $pEnvBlock)
	$pEnvBlock = 0
	$ret = DllCall($ghADVAPI32, "bool", "CreateProcessWithTokenW",  "handle", $hDupToken,  "dword", 1,  "ptr", 0,  "wstr", $sCmdLine,  "dword", $dwCreationFlags,  "ptr", $pEnvBlock,  "wstr", @WindowsDir,  "ptr", DllStructGetPtr($SI),  "ptr", DllStructGetPtr($PI))
	ConsoleWrite("RunasSystem: CreateProcessWithTokenW=" & $ret[0] & "  error=" & @error & " LastError=" & _WinAPI_GetLastError() & @CRLF)
EndIf

If @error or Not $ret[0] Then
	ConsoleWrite("RunasSystem: CreateProcessWithTokenW: " & _WinAPI_GetLastErrorMessage() & @CRLF)
	$ret = DllCall($ghADVAPI32, "int", "CreateProcessAsUserW", "handle", $hDupToken, "ptr", 0, "wstr", $sCmdLine, "ptr", 0, "ptr", 0, "int", 0, "dword", $dwCreationFlags, "ptr", $pEnvBlock, "ptr", 0, "ptr", DllStructGetPtr($SI), "ptr", DllStructGetPtr($PI))
	ConsoleWrite("RunasSystem: CreateProcessAsUserW=" & $ret[0] & "  error=" & @error & @CRLF)
	If Not @error And $ret[0] Then
		ConsoleWrite("RunasSystem: New process created successfully: " & DllStructGetData($PI, "dwProcessId") & @CRLF)
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", DllStructGetData($PI, "hThread"))
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", DllStructGetData($PI, "hProcess"))
	Else
		ConsoleWrite("RunasSystem: CreateProcessAsUserW: " & _WinAPI_GetLastErrorMessage() & @CRLF)
	EndIf
EndIf

If $pEnvBlock Then DllCall("userenv.dll", "int", "DestroyEnvironmentBlock", "ptr", $pEnvBlock)
DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hDupToken)
DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
;Local $iAnswer = MsgBox(BitOR($MB_YESNO, $MB_SYSTEMMODAL), "RunasSystem", "Exit")



Func _GetEnvironmentBlock($sProcess, $dwSession)
	Local Const $MAXIMUM_ALLOWED1 = 0x02000000
	Local Const $dwAccess = BitOR(0x2, 0x8) ; TOKEN_DUPLICATE | TOKEN_QUERY

	; get PID of process in current session
	Local $aProcs = ProcessList($sProcess), $processPID = -1, $ret = 0
	For $i = 1 To $aProcs[0][0]
		$ret = DllCall("kernel32.dll", "int", "ProcessIdToSessionId", "dword", $aProcs[$i][1], "dword*", 0)
		If Not @error And $ret[0] And ($ret[2] = $dwSession) Then
			$processPID = $aProcs[$i][1]
			ExitLoop
		EndIf
	Next
	If $processPID = -1 Then Return 0 ; failed to get PID
	; open process
	Local $hProc = DllCall("kernel32.dll", "ptr", "OpenProcess", "dword", 0x02000000, "int", 0, "dword", $processPID)
	If @error Or Not $hProc[0] Then Return 0
	$hProc = $hProc[0]
	; open process token
	$hToken = DllCall($ghADVAPI32, "int", "OpenProcessToken", "ptr", $hProc, "dword", $dwAccess, "ptr*", 0)
	If @error Or Not $hToken[0] Then
		ConsoleWrite("RunasSystem: OpenProcessToken: " & _WinAPI_GetLastErrorMessage() & @CRLF)
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
		Return 0
	EndIf
	$hToken = $hToken[3]
	; create a new environment block
	Local $pEnvBlock = DllCall("userenv.dll", "int", "CreateEnvironmentBlock", "ptr*", 0, "ptr", $hToken, "int", 1)
	If Not @error And $pEnvBlock[0] Then $ret = $pEnvBlock[1]
	; close handles
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
	Return $ret
EndFunc

Func _SetPrivilege($Privilege)
    Local $tagLUIDANDATTRIB = "int64 Luid;dword Attributes"
    Local $count = 1
    Local $tagTOKENPRIVILEGES = "dword PrivilegeCount;byte LUIDandATTRIB[" & $count * 12 & "]" ; count of LUID structs * sizeof LUID struct
    Local $TOKEN_ADJUST_PRIVILEGES = 0x20
    Local $SE_PRIVILEGE_ENABLED = 0x2

    Local $curProc = DllCall("kernel32.dll", "ptr", "GetCurrentProcess")
	Local $call = DllCall("advapi32.dll", "int", "OpenProcessToken", "ptr", $curProc[0], "dword", $TOKEN_ALL_ACCESS, "ptr*", "")
    If Not $call[0] Then Return False
    Local $hToken = $call[3]

    $call = DllCall("advapi32.dll", "int", "LookupPrivilegeValue", "str", "", "str", $Privilege, "int64*", "")
    Local $iLuid = $call[3]

    Local $TP = DllStructCreate($tagTOKENPRIVILEGES)
	Local $TPout = DllStructCreate($tagTOKENPRIVILEGES)
    Local $LUID = DllStructCreate($tagLUIDANDATTRIB, DllStructGetPtr($TP, "LUIDandATTRIB"))

    DllStructSetData($TP, "PrivilegeCount", $count)
    DllStructSetData($LUID, "Luid", $iLuid)
    DllStructSetData($LUID, "Attributes", $SE_PRIVILEGE_ENABLED)

    $call = DllCall("advapi32.dll", "int", "AdjustTokenPrivileges", "ptr", $hToken, "int", 0, "ptr", DllStructGetPtr($TP), "dword", DllStructGetSize($TPout), "ptr", DllStructGetPtr($TPout), "dword*", 0)
	$lasterror = _WinAPI_GetLastError()
	If $lasterror <> 0 Then
		ConsoleWrite("RunasSystem: AdjustTokenPrivileges ("&$Privilege&"): " & _WinAPI_GetLastErrorMessage() & @CRLF)
		If $lasterror = 1300 Then
			$RightsAdder = _LsaAddAccountRights(@UserName, $Privilege)
			If not @error then
				ConsoleWrite("RunasSystem: Reboot required for changes to take effect" & @CRLF)
			Else
				ConsoleWrite("RunasSystem: Error: The right was probably not added correctly to your account" & @CRLF)
				Return SetError(1,0,0)
			EndIf
		EndIf
	EndIf
    DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
    Return ($call[0] <> 0) ; $call[0] <> 0 is success
EndFunc

Func _LsaAddAccountRights($sName, $sRight)
	Local $hPolicy, $tSid, $pSid, $iLength, $iSysError
	Local $tUnicode, $pUnicode, $iResult, $tRight, $pRight
	$tSid = _LookupAccountName($sName)
	$pSid = DllStructGetPtr($tSid)
	If Not _IsValidSid($pSid) Then Return SetError(@error, 0, 0)
	$hPolicy = _LsaOpenPolicy(0x811)
	$iLength = StringLen($sRight) * 2
	$tRight = DllStructCreate("wchar[" & $iLength & "]")
	$pRight = DllStructGetPtr($tRight)
	DllStructSetData($tRight, 1, $sRight)
	$tUnicode = DllStructCreate("ushort Length;ushort MemSize;ptr wBuffer")
	$pUnicode = DllStructGetPtr($tUnicode)
	DllStructSetData($tUnicode, "Length", $iLength)
	DllStructSetData($tUnicode, "MemSize", $iLength + 2)
	DllStructSetData($tUnicode, "wBuffer", $pRight)
	$iResult = DllCall("advapi32.dll", "dword", "LsaAddAccountRights", _
					"hWnd", $hPolicy, "ptr", $pSid, _
					"ptr", $pUnicode, "ulong", 1)
;	ConsoleWrite("RunasSystem: LsaAddAccountRights Dec " & _LsaNtStatusToWinError($iResult[0]) & @CRLF)
	ConsoleWrite("RunasSystem: LsaAddAccountRights 0x" & Hex(_LsaNtStatusToWinError($iResult[0]),8) & @CRLF)
	$tSid = 0
	_LsaClose($hPolicy)
	$iSysError = _LsaNtStatusToWinError($iResult[0])
	Return SetError($iSysError, 0, $iSysError = 0)
EndFunc

Func _LsaOpenPolicy($iAccess)
	Local $hPolicy, $tLsaAttr, $pLsaAttr
	$tLsaAttr = DllStructCreate("ulong;hWnd;ptr;ulong;ptr[2]")
	$pLsaAttr = DllStructGetPtr($tLsaAttr)
	$hPolicy = DllCall("advapi32.dll", "ulong", "LsaOpenPolicy", _
					"ptr", 0, "ptr", $pLsaAttr, "int", $iAccess, "hWnd*", 0)
	Return SetError(_LsaNtStatusToWinError($hPolicy[0]), 0, $hPolicy[4])
EndFunc

Func _LsaClose($hPolicy)
        Local $iResult
        $iResult = DllCall("advapi32.dll", "ulong", "LsaClose", "hWnd", $hPolicy)
        Return SetError(_LsaNtStatusToWinError($iResult[0]), 0, $iResult[0] = 0)
EndFunc

Func _LookupAccountName($sName, $sSystem = "")
        Local $iResult, $tSid, $pSid, $tDomain, $pDomain
        $iResult = DllCall("advapi32.dll", "int", "LookupAccountName", _
                        "str", $sSystem, "str", $sName, _
                        "ptr", 0, "int*", 0, "ptr", 0, "int*", 0, "int*", 0)
        If $iResult[4] = 0 Then Return SetError($ERROR_INVALID_SID, 0, 0)
        $tSid = DllStructCreate("ubyte[" & $iResult[4] & "]")
        $tDomain = DllStructCreate("ubyte[" & $iResult[6] & "]")
        $pSid = DllStructGetPtr($tSid)
        $pDomain = DllStructGetPtr($tDomain)
        $iResult = DllCall("advapi32.dll", "int", "LookupAccountName", _
                        "str", $sSystem ,"str", $sName, _
                        "ptr", $pSid, "int*", $iResult[4], _
                        "ptr", $pDomain, "int*", $iResult[6], "int*", 0)
        Return SetError(Not $iResult[0], $iResult[7], $tSid)
EndFunc

Func _IsValidSid($pSid)
        Local $iResult
        $iResult = DllCall("advapi32.dll", "int", "IsValidSid", "ptr", $pSid)
        If $iResult[0] Then Return SetError(0, 0, True)
        Return SetError($ERROR_INVALID_SID, 0, 0)
EndFunc

Func _LsaNtStatusToWinError($iNtStatus)
	Local $iSysError
	$iSysError = DllCall("Advapi32.dll", "ulong", "LsaNtStatusToWinError", "dword", $iNtStatus)
	Return $iSysError[0]
EndFunc

Func NT_SUCCESS($status)
    If 0 <= $status And $status <= 0x7FFFFFFF Then
        Return True
    Else
        Return False
    EndIf
EndFunc